PUD: fix compile warnings